#include "Game.h"
#include <Bild.h>

// Inhalt der Game Klasse aus Game.h
// Konstruktor
Game::Game()
    : ReferenceCounter()
{
    alpha = 0;
    men = 0;
    client = 0;
}

// Destruktor
Game::~Game()
{
    if( client )
        client->release();
    if( men )
        men->release();
}

// nicht constant
bool Game::laden()
{
    return 1;
}

void Game::setMinigameClientZ( KSGClient::MinigameServerClient *client )
{
    if( this->client )
        this->client->release();
    this->client = client;
}

void Game::setMinigameAPI( MinigameAPI *api )
{

}

void Game::doPublicMausEreignis( MausEreignis &me )
{
    if( men )
        men->doPublicMausEreignis( me );
}

void Game::doTastaturEreignis( TastaturEreignis &te )
{
    if( men )
        men->doTastaturEreignis( te );
}

bool Game::tick( double zeit )
{
    int val = (int)( zeit * 150 );
    if( men && !men->istBeendet() && alpha != 255 )
    {
        alpha += val;
        if( alpha > 255 )
            alpha = 255;
        return 1;
    }
    if( men && men->istBeendet() && alpha )
    {
        alpha -= val;
        if( alpha < 255 )
            alpha = 0;
    }
    if( men )
        return men->tick( zeit );
    return 0;
}

void Game::render( Bild &zRObj )
{
    zRObj.setAlpha( alpha );
    if( men )
        men->render( zRObj );
    zRObj.releaseAlpha();
}

void Game::setUIFactory( UIInit &uiFactory )
{
    this->uiFactory = uiFactory;
    if( !men )
        men = new Men( uiFactory, dynamic_cast<KSGClient::MinigameServerClient *>( client->getThis() ) );
}

// constant
bool Game::istEnde() const
{
    return men ? ( men->istBeendet() && !alpha ) : 0;
}